#include<iostream>
#include<vector>
#include<algorithm>
#include<cstring>
#include<cstdlib>
#include<fstream>
#include<string>

using namespace std;

int uffind(vector<int>& chief, int a){
	if(chief[a] == a) return a;
	else return chief[a] = uffind(chief, chief[a]);
}

void ufunion(vector<int>&chief, int a, int b){
	chief[uffind(chief,a)] = uffind(chief,b);
}

int main(int argc, char** argv){
	ios_base::sync_with_stdio(0);
	string outfile = getenv("SPRW_WORKING_DIR"); outfile+="/taskdata/"; outfile+=getenv("SPR_outfile");
	string infile = getenv("SPRW_WORKING_DIR"); infile+="/taskdata/"; infile+=getenv("SPR_infile");
	//string outfile("0.out");
	//string infile("0.in");
	int resp, resok;
	ifstream in(infile.c_str());
	ifstream out(outfile.c_str());
	
	int lz;
	in >> lz;
	while(lz--){
		int n;
		in >> n;
		vector<int> wzorcowe(n);
		for(int i =0; i < n; i++) in >> wzorcowe[i];
		
		string odp, uodp;
		out >> odp;
		cin >> uodp;
		if(odp != uodp) return 1;
		if(odp == "TAK"){
			vector<int> chief(n);
			for(int i =0; i < n; i++) chief[i] = i;
			int m;
			cin >> m;
			vector<int> deg(n);
			for(int i =0; i < m; i++){
				int a, b;
				cin >> a >> b;
				
				if(a <= 0 || a > n || b <= 0 || b > n) return 1;
				deg[a-1]++;
				deg[b-1]++;
				if(uffind(chief,a-1)==uffind(chief,b-1)) return 1;
				ufunion(chief,a-1,b-1);
			}
			sort(wzorcowe.begin(), wzorcowe.end());
			sort( deg.begin(), deg.end());
			if(wzorcowe != deg) return 1;
		}
	}
	if(cin.bad() || cin.fail()) return 1;
	return 0;
}
